// WRITELAYOUT.CPP - Implementation file for your Internet Server
//    WriteLayout Extension

#include "stdafx.h"
#include "WriteLayout.h"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;


///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CWriteLayoutExtension, CHttpServer)
	// TODO: insert your ON_PARSE_COMMAND() and 
	// ON_PARSE_COMMAND_PARAMS() here to hook up your commands.
	// For example:

	ON_PARSE_COMMAND(Default, CWriteLayoutExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CWriteLayoutExtension)


	ON_PARSE_COMMAND(WritePageDemo, CWriteLayoutExtension, ITS_EMPTY)
	ON_PARSE_COMMAND(WritePageDB2Web, CWriteLayoutExtension, ITS_EMPTY)

END_PARSE_MAP(CWriteLayoutExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CWriteLayoutExtension object

CWriteLayoutExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CWriteLayoutExtension implementation

CWriteLayoutExtension::CWriteLayoutExtension()
{
	  
	m_bstrConnectionString		= L"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Projects\\Articles\\ISAPIdbAccess\\Work\\DB\\Db2Isapi.mdb";
	m_bstrConnectionString		= L"File Name=C:\\DataLinks\\ConnectionArticleDB2Isapi.udl";

}

CWriteLayoutExtension::~CWriteLayoutExtension()
{
}

BOOL CWriteLayoutExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string 
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);


															//load at the beginning :
	LoadLongResource(strPageDemo, IDR_HTML_PAGE_DEMO);		//the entire hardcoded page
	
	LoadLongResource(strPagePart1, IDR_HTML_PAGE_PART1);	//first  piece of hardcoded page
	LoadLongResource(strPagePart2, IDR_HTML_PAGE_PART2);	//second piece of hardcoded page
	LoadLongResource(strPagePart3, IDR_HTML_PAGE_PART3);	//third	 piece of hardcoded page
	LoadLongResource(strPagePart4, IDR_HTML_PAGE_PART4);	//five	 piece of hardcoded page	
	

	return TRUE;
}

BOOL CWriteLayoutExtension::TerminateExtension(DWORD dwFlags)
{
	// extension is being terminated
	//TODO: Clean up any per-instance resources
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CWriteLayoutExtension command handlers

void CWriteLayoutExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);	

	*pCtxt << _T("This default message was produced by the Internet");
	*pCtxt << _T(" Server DLL Wizard. Edit your CWriteLayoutExtension::Default()");
	*pCtxt << _T(" implementation to change it.\r\n");
	*pCtxt << "<hr/>";
	
	
	
	*pCtxt << "<p>" <<_T(" Try <a href=WriteLayout.dll?WritePageDB2Web>WritePageDB2Web?</a> function. (with DB calls)");

	*pCtxt << "<p>" <<_T(" Try <a href=WriteLayout.dll?WritePageDemo>WritePageDemo?</a> function. (without DB calls, hardcoded HTML data)");

	Beep(200,200);

	EndContent(pCtxt);
}



void CWriteLayoutExtension::WritePageDemo(CHttpServerContext* pCtxt)
{
	//StartContent(pCtxt);
	//WriteTitle(pCtxt);

	
	//___________________________________________________
	//my code here

	*pCtxt << strPageDemo;
	//___________________________________________________



	//EndContent(pCtxt);
}



void CWriteLayoutExtension::WritePageDB2Web(CHttpServerContext* pCtxt)
{
	_bstr_t									bstrOutput(_T(""));
	_bstr_t									bstrError(_T(""));

	//Beep(200,60);	
	//_____________________________________________
	//open db,
	//and keep the connection open to all calls to db
	CAdoDatabase							AdoDB;

	if ( !DBConnectionOpen(m_bstrConnectionString, &AdoDB) )
	{
		//some log here
		//LOG_ERROR(L"Construct", L"The DB wasn't open.", L"DB error.", m_bstrConnectionString);
		Beep(900, 200);
	}
	//_____________________________________________
	//Beep(200,60);


	//The output page will be:
	//*pCtxt << strPagePart1	+ GetArticlesFeature [some HTML builded from DB] + 
	//			strPagePart2	+ GetArticlesTopRated[some HTML builded from DB] + 
	//			strPagePart3	+ GetArticlesLast10	 [some HTML builded from DB] + 
	//			strPagePart4.
	//(will have 3 fixed parts and 2 parts dynamically, from DB)
	
	
	//1, fixed part:
	*pCtxt << strPagePart1;
	
	//_______________________________________________________________________________________
	//2, dynamic part:											//GetArticlesFeature
	if ( ! GetArticlesFeature(AdoDB, &bstrOutput, &bstrError) )
	{
		*pCtxt << bstrError;									//if its an error display it
		return;
	}
	*pCtxt << bstrOutput;										//write part
	//_______________________________________________________________________________________
	
	//3, fixed part:
	*pCtxt << strPagePart2;
	
	//_______________________________________________________________________________________
	//4, dynamic part:											//GetArticlesTopRated
	if ( ! GetArticlesTopRated(AdoDB, &bstrOutput, &bstrError) )
	{
		*pCtxt << bstrError;									//if its an error display it
		return;
	}
	*pCtxt << bstrOutput;										//write part
	//_______________________________________________________________________________________

	//5, fixed part:
	*pCtxt << strPagePart3;
	
	//_______________________________________________________________________________________
	//6, dynamic part:											//GetArticlesLast10
	if ( ! GetArticlesLast10(AdoDB, &bstrOutput, &bstrError) )
	{
		*pCtxt << bstrError;									//if its an error display it
		return;
	}
	*pCtxt << bstrOutput;										//write part
	//_______________________________________________________________________________________

	//7, fixed part:
	*pCtxt << strPagePart4;

	
}


bool CWriteLayoutExtension::GetArticlesFeature(CAdoDatabase AdoDB, _bstr_t *bstrOutput, _bstr_t *bstrError)
{											//the sql stmt string
	_bstr_t									bstrSTMT(L"SELECT * from tblArticles where type=1");	

	MACRO_BEGIN								//here the begin code from macro
		
		_bstr_t								bstrValue_link, bstrValue_title,bstrValue_author, bstrValue_headline;	
		
		while ( !AdoRS->IsEof() )			//if we have records
		{
			AdoRS->GetFieldValue("link",	&bstrValue_link );
			AdoRS->GetFieldValue("title",	&bstrValue_title );
			AdoRS->GetFieldValue("author",	&bstrValue_author );
			AdoRS->GetFieldValue("headline",&bstrValue_headline );
			
			wsprintf(wcOut, 
							"<TR>"\
								"<TD width=100%%><FONT class=links size=1><A href=%s>%s</A><BR>"\
								"by <B>%s</B><BR>"\
								"<FONT color=black>%s</FONT>"\
								"</TD>"\
							"</TR>",
					(LPCTSTR)bstrValue_link, (LPCTSTR)bstrValue_title, (LPCTSTR)bstrValue_author, (LPCTSTR)bstrValue_headline
					);
			
			AdoRS->MoveNext();
			
			*bstrOutput	= (LPCTSTR)wcOut;	//the output here
		}

	MACRO_END								//here the end code from macro
}

bool CWriteLayoutExtension::GetArticlesTopRated(CAdoDatabase AdoDB, _bstr_t *bstrOutput, _bstr_t *bstrError)
{

	_bstr_t									bstrSTMT("SELECT * from tblArticles where type=2");


	MACRO_BEGIN

		_bstr_t								bstrValue_link, bstrValue_title,bstrValue_author, bstrValue_headline, bstrValue_votes, bstrValue_category;

		while ( !AdoRS->IsEof() )						//if we have records
		{
			AdoRS->GetFieldValue("link",	&bstrValue_link );
			AdoRS->GetFieldValue("title",	&bstrValue_title );
			AdoRS->GetFieldValue("author",	&bstrValue_author );
			AdoRS->GetFieldValue("headline",&bstrValue_headline );
			AdoRS->GetFieldValue("votes",	&bstrValue_votes );
			AdoRS->GetFieldValue("category",&bstrValue_category );



			wsprintf(wcOut, 
							"<TR>\n"\
								"<TD class=smallText width=100%%><A title=\"%s\" href=\"%s\">%s</A><BR>\n"\
								   "<B>%s</B></TD>\n"\
								"<TD class=links vAlign=top noWrap \n"\
								  "align=right>%s/5 (%s votes)<BR><I><A href=%s>%s</A></I>\n"\
								 "</TD>\n"\
						   "</TR>\n",
						   (LPCTSTR)bstrValue_headline, (LPCTSTR)bstrValue_link, (LPCTSTR)bstrValue_title,  
						   (LPCTSTR)bstrValue_author, 
						   (LPCTSTR)bstrValue_votes, (LPCTSTR)bstrValue_votes, (LPCTSTR)bstrValue_category, (LPCTSTR)bstrValue_category
					);

			AdoRS->MoveNext();

			//the output here
			*bstrOutput			+= (LPCTSTR)wcOut;
		}

	MACRO_END	
}

bool CWriteLayoutExtension::GetArticlesLast10(CAdoDatabase AdoDB, _bstr_t *bstrOutput, _bstr_t *bstrError)
{
	_bstr_t									bstrSTMT("SELECT * from tblArticles where type=3");


	MACRO_BEGIN


		_bstr_t								bstrValue_link, bstrValue_title,bstrValue_author, bstrValue_headline, bstrValue_date, bstrValue_stage;
	
		while ( !AdoRS->IsEof() )						//if we have records
		{
			AdoRS->GetFieldValue("link",	&bstrValue_link );
			AdoRS->GetFieldValue("title",	&bstrValue_title );
			AdoRS->GetFieldValue("author",	&bstrValue_author );
			AdoRS->GetFieldValue("headline",&bstrValue_headline );
			AdoRS->GetFieldValue("date",	&bstrValue_date );
			AdoRS->GetFieldValue("stage",	&bstrValue_stage );



			wsprintf(wcOut, 
							"<TR>"\
								"<TD vAlign=top noWrap><FONT class=links size=1>%s&nbsp;&nbsp;<BR><FONT color=darkorange size=1>(%s)</FONT></FONT>"\
								"</TD>"\
								"<TD width=100%%><FONT class=links size=1><A title=\"%s\""\
									"href=\"%s\">%s</A><BR><B>%s</B>"\
									"[unedited]</FONT>"\
								"</TD>"\
							"</TR>",
						   (LPCTSTR)bstrValue_date, (LPCTSTR)bstrValue_stage, 
						   (LPCTSTR)bstrValue_headline, 
						   (LPCTSTR)bstrValue_link, (LPCTSTR)bstrValue_title,  (LPCTSTR)bstrValue_author
					);

			AdoRS->MoveNext();

			//the output here
			*bstrOutput			+= (LPCTSTR)wcOut;
		}
				
	MACRO_END	
}


//################################################################################################
//here helper methods

bool CWriteLayoutExtension::DBConnectionOpen(_bstr_t bstrConnection, CAdoDatabase	*m_AdoDB)
{		

	_bstr_t			bstrErr;
	HRESULT			hr = S_OK;
	
	try 
	{
		if ( m_AdoDB->IsOpen() )													//if DB is already open return
			return	true;
		else
		{
			if (m_AdoDB->Open(bstrConnection) )									//if not, open the link with DB
			{
				return true;
			}
			else 
			{
				return false;
			}
		}
		
	}
	catch(_com_error err)
	{
		// catch exceptions thrown by ADO COM-smartptr wrappers
		bstrErr		= err.Description();
		hr			= err.Error();
		Beep(900, 200);
		return false;
	}

	return true;
}


BOOL CWriteLayoutExtension::LoadLongResource(CString& str, UINT nID)
{
	HRSRC				hRes;
	HINSTANCE			hInst			= AfxGetResourceHandle();
	BOOL				bResult			= FALSE;
	static const TCHAR	szHTMLType[]	= _T("CustomHTML");

	//hRes = FindResource(hInst, MAKEINTRESOURCE(nID), szHTMLType);		//if you want you custom resource type
	hRes = FindResource(hInst, MAKEINTRESOURCE(nID), RT_HTML);			//if you want standard html type
	if (hRes == NULL)
		ISAPITRACE1("Error: Resource %d could not be found\r\n", nID);
	else
	{
		DWORD dwSize = SizeofResource(hInst, hRes);
		if (dwSize == 0)
		{
			str.Empty();
			bResult = TRUE;
		}
		else
		{
			LPTSTR pszStorage = str.GetBufferSetLength(dwSize);

			HGLOBAL hGlob = LoadResource(hInst, hRes);
			if (hGlob != NULL)
			{
				LPVOID lpData = LockResource(hGlob);

				if (lpData != NULL)
				{
					memcpy(pszStorage, lpData, dwSize);
					bResult = TRUE;
				}

				FreeResource(hGlob);
			}
		}
	}

#ifdef _DEBUG
	if (!bResult)
		str.Format(_T("<b>Could not find string %d</b>"), nID);
#endif

	return bResult;
}

//################################################################################################



// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CWriteLayoutExtension, CHttpServer)
	//{{AFX_MSG_MAP(CWriteLayoutExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/


